<template>
  <q-page class="q-pl-md q-mb-md bg-grey-1 splitscreen" role="presentation">
    <q-splitter class="splitscreen__splitter" v-model="panelWidth" :limits="[50,100]">
      <template v-slot:before>

        <q-card flat class="q-pb-md">
          <div v-if="linkrole">
            <q-card-section class="text-primary section_heading__border text-weight-bold" :key="language_switch"
                            role="heading" aria-level="1">
              {{ get_label(linkrole) }}
            </q-card-section>
            <q-item-label class="q-pa-sm" caption>{{ linkrole.role_uri }}</q-item-label>

            <!-- a table, an hypercube or even a presentation can render a table  -->
            <q-expansion-item label="Rendered table" header-class="heading_expansion__table" default-opened
                              expand-icon-class="text-orange-10" switch-toggle-side
                              v-if="linkrole.presentation_hierarchy || linkrole.tables.length || linkrole.hypercube">
              <HtmlTable
                :dts_name="dts_name"
                :linkrole_id="linkrole_id"
                :nt_version="nt_version"
                :linkrole_role_uri="linkrole_role_uri"
                v-on:nodeClicked="node_clicked"
              ></HtmlTable>
            </q-expansion-item>

            <q-expansion-item label="Definition Link" header-class="heading_expansion__hypercube" default-opened
                              expand-icon-class="text-blue-8" switch-toggle-side
                              v-if="linkrole.hypercube">
              <DefinitionLinkDetailCard
                :hypercube="linkrole.hypercube"
                :nt_version="nt_version"
                v-on:conceptClicked="concept_clicked"
                v-on:dim_conceptClicked="dim_concept_clicked"></DefinitionLinkDetailCard>
            </q-expansion-item>

            <q-expansion-item label="Table" header-class="heading_expansion__table"
                              expand-icon-class="text-orange-10" switch-toggle-side
                              default-opened role="region" aria-label="Table"
                              v-if="linkrole.tables.length">
              <q-card v-for="table in linkrole.tables" v-bind:key="table.id">
                <TableDetailCard v-bind:table="table"></TableDetailCard>
                <ParameterDetail v-bind:table="table" v-if="table.parameters.length"></ParameterDetail>
              </q-card>
            </q-expansion-item>

            <q-expansion-item label="Target for" header-class="heading_expansion__targeted"
                              expand-icon-class="text-green-10" switch-toggle-side
                              default-opened
                              v-if="linkrole.targeted_by">
              <DimensionCard
                v-on:dim_conceptClicked="dim_concept_clicked"
                :dimension="linkrole.targeted_by[0]"></DimensionCard>
            </q-expansion-item>
            <q-expansion-item label="Dimension" header-class="heading_expansion__targeted"
                              expand-icon-class="text-green-10" switch-toggle-side
                              default-opened
                              v-if="linkrole.dimensions">
              <DimensionCard
                v-on:dim_conceptClicked="dim_concept_clicked"
                :dimension="linkrole.dimensions[0]"></DimensionCard>
            </q-expansion-item>

            <q-expansion-item label="Presentation Hierarchy" header-class="heading_expansion__presentation"
                              expand-icon-class="text-teal-10" switch-toggle-side
                              default-opened
                              v-if="linkrole.presentation_hierarchy">
              <PresentationHierarchyTree :presentation_hierarchy="[linkrole.presentation_hierarchy]"
                                         v-on:nodeClicked="node_clicked">
              </PresentationHierarchyTree>
            </q-expansion-item>
            <VariableDetail v-bind:variables="linkrole.variables" v-if="linkrole.variables.length"></VariableDetail>

          </div>
        </q-card>
      </template>

      <template v-slot:separator>
      </template>

      <template v-slot:after>
        <div v-if="node">
          <CellValue :node="node" v-on:close_detail="close_detail"></CellValue>
        </div>
      </template>

    </q-splitter>
  </q-page>
</template>

<script>
import {api} from 'boot/axios'
import DefinitionLinkDetailCard from "./DefinitionLinkDetailCard";
import TableDetailCard from "components/TableDetailCard";
import _ from "lodash"
import ParameterDetail from "components/ParameterDetail";
import VariableDetail from "components/VariableDetail";
import HtmlTable from "components/HtmlTable";
import DimensionCard from "components/DimensionCard";
import CellValue from "components/CellValue";
import SharedMethods from "components/SharedMethods";
import PresentationHierarchyTree from "components/PresentationHierarchyTree";


export default {
  name: "LinkroleDetail",
  components: {
    PresentationHierarchyTree,
    CellValue,
    DimensionCard,
    HtmlTable,
    VariableDetail,
    ParameterDetail,
    TableDetailCard,
    DefinitionLinkDetailCard
  },
  data() {
    return {
      linkrole: undefined,
      panelWidth: 100,
      node: null,
      language_switch: undefined
    }
  },
  created() {
    this.label_nice_role = SharedMethods.label_nice_role
    this.get_label = SharedMethods.get_label
    this.fetchData()
  },
  props: {
    linkrole_id: String,
    linkrole_role_uri: String,
    dts_name: String,
    nt_version: String,
  },
  watch: {
    linkrole_id: function () {
      this.fetchData()
    },
    "$route.query.lang": function () {
      this.language_switch = this.$route.query.lang
    }
  },
  methods: {
    fetchData: function () {
      if (!_.isUndefined(this.dts_name)) {
        console.log(this.linkrole_role_uri)
        api
          .get("/dts/" + this.dts_name + "/linkroles/" + this.linkrole_id,
            {params: {nt_version: this.nt_version, full: 1, roleURI: this.linkrole_role_uri}})
          .then(response => {
            this.linkrole = response.data[0]
            let scrollscreen = document.getElementsByClassName("q-splitter__before")[0]
            if (scrollscreen) {
              scrollscreen.scrollTop = 0
            }
          })
      }
    },
    showHide: function () {
      if (this.panelWidth === 100) {
        this.panelWidth = 75
      } else if (this.panelWidth === 75) {
        this.panelWidth = 50
      } else {
        this.panelWidth = 100
      }
    },
    node_clicked: function (node) {
      if (node) {
        this.node = node
        if (this.panelWidth === 100) {
          this.panelWidth = 75
        }
      }
    },
    concept_clicked: function (concept_id) {
      let line_items = this.linkrole.hypercube.line_items.filter(
        line_item => line_item.concept && line_item.concept.id === concept_id
      )
      if (line_items.length) {
        this.node_clicked(line_items[0])
      }
    },
    dim_concept_clicked: function (concept) {
      this.node_clicked({concept: concept})
    },
    close_detail: function () {
      this.panelWidth = 100
    }
  }
}
</script>

<style scoped lang="scss">
.section_heading__border {
  border-bottom: 1px solid $primary;
  font-size: 20px;
  margin-bottom: 10px;
}

.show_hide {
  position: sticky;
  top: 130px;
}

.splitscreen__splitter {
  height: calc(100vh - 150px);
  width: 98%;
}

.detail--padding {
  padding: 30px;
}

.pad-1 {
  padding-left: 15px;
}

.row {
  padding: 5px 0 0 0;
}

.label {
  padding: 5px 0 5px 10px;
}

table {
  border-spacing: 5px;
  widht: 100%;
}

th {
  text-align: left;
}

</style>
